=== debian/changelog ===
libsfml (2.6.2+dfsg-2) unstable; urgency=medium

  * d/tests: Bump minimum CMake version to 3.25. (Closes: #1087861)

 -- James Cowgill <jcowgill@debian.org>  Tue, 19 Nov 2024 16:45:47 +0000

libsfml (2.6.2+dfsg-1) unstable; urgency=medium

  * New upstream version.

  * d/copyright: Minor updates for 2.6.2.
  * d/patches: Refresh patches.

 -- James Cowgill <jcowgill@debian.org>  Mon, 11 Nov 2024 17:23:19 +0000
