=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DSFML_BUILD_DOC=ON \
		-DSFML_BUILD_EXAMPLES=ON \
		-DSFML_BUILD_TEST_SUITE=ON

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_installexamples:
	dh_installexamples -X.gitignore

override_dh_compress:
	dh_compress -XSFML.tag
