=== debian/tests/control ===
Tests: build
Depends: g++, libsfml-dev, pkg-config
Restrictions: superficial

Tests: cmake
Depends: cmake, g++, libsfml-dev, make
Restrictions: superficial
